<?php
error_reporting(E_ALL);

$SCRIPTPATH=str_replace("\\","/",realpath(dirname(__FILE__)))."/";
require("{$SCRIPTPATH}init.php");

if(!isset($argv))
{
	if(isset($_SERVER["argv"]))
		$argv=$_SERVER["argv"];
	else
	{
		addError("Unable to retrieve the arguments in ".__FILE__.". Make sure you have 'register_argc_argv=On' in you php.ini file!");
		exit();
	}
}

if(sizeof($argv) < 3)
{
	addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
	exit();
}

require("sfv.php");

$type=$argv[1];
$fullname=$argv[2];
$username=$argv[3];
$usergroup=$argv[4];

switch($type)
{
case "file":
	{
		if(sizeof($argv) < 5)
		{
			addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
			exit();
		}

		$fullpath=dirname($fullname)."\\";
		initPathVars();
		$filename=strtolower(basename($fullname));
		$extension=substr($filename,strrpos($filename,".")+1);
		$nbfiles=0;

		if(delete_file($release,$filename) && (file_exists("{$fullpath}file_id.diz") || findSfv()!=""))
		{
			if(strtolower($extension)=="zip")
			{
				require("zip.php");
				if(isset($RIPPATH))
				{
					foreach($RIPPATH as $dirn)
					{
						if($dirn != "")
						{
							if(stristr($fullpath,str_replace("/","\\",$dirn)))
							{
								verifNbFile(false);
							}
						}
					}
				}

				if(isset($ROMSPATH))
				{
					foreach($ROMSPATH as $dirn)
					{
						if($dirn != "")
						{
							if(stristr($fullpath,str_replace("/","\\",$dirn)))
							{
								verifNbFile(true);
							}
						}
					}
				}
			}
			else
			{
				$sfvFileName=findSfv();

				if($sfvFileName!="")
				{
					$sfv=analyseSfv($sfvFileName);
					if(isset($sfv[$filename]))
					{
						$nbfiles=sizeof($sfv);
					}
				}
			}

			if($nbfiles)
			{
				process_raceinfo();
				global $MISSINGFILESSUFFIX;
				$MISSINGFILESSUFFIX=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MISSINGFILESSUFFIX);
				if(!isset($MISSINGFILESSUFFIX) || $MISSINGFILESSUFFIX=="")
					$MISSINGFILESSUFFIX="-missing";

				createMissingTags(array($filename));
			}
		}
		else
		{
			if($filename=="file_id.diz")
			{
				if(!isset($MESSAGEFILENAME) || $MESSAGEFILENAME=="")
					$MESSAGEFILENAME=".message";

				delIncompleteTags();			
				if(file_exists($fullpath.$MESSAGEFILENAME))
				{
					unlink($fullpath.$MESSAGEFILENAME);
					$aclFiles["releaseDir"]->delete($MESSAGEFILENAME);
				}

				// should use the delIncompleteTags function
				$MISSINGFILESSUFFIX=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MISSINGFILESSUFFIX);
				if(!isset($MISSINGFILESSUFFIX) || $MISSINGFILESSUFFIX=="")
					$MISSINGFILESSUFFIX="-missing";

				$missingSuffixLength=strlen($MISSINGFILESSUFFIX);

				$handle=opendir($fullpath);
				while($file = readdir($handle))
				{
					if( strtolower(substr($file,-$missingSuffixLength)) == strtolower($MISSINGFILESSUFFIX))
					{
						unlink($fullpath.$file);
						$aclFiles["releaseDir"]->delete($file);
					}
				}
				closedir($handle);
			}
		}
		break;
	}
case "dir":
	{
		$fullpath=$fullname."\\";
		initPathVars();
		delete_release($release);
		break;
	}
}
?>
