<?php
$scriptVersion="0.79b";
error_reporting(E_ALL);
function addShutdownFunction($function)
{
	global $shutdownFunctions;
	$shutdownFunctions[]=$function;
}

function callShutdownFunctions()
{
	global $shutdownFunctions;
	if(isset($shutdownFunctions))
	{
		foreach($shutdownFunctions as $shutdownFunction)
		{
			$shutdownFunction();
		}
	}
}

function updateAclFiles()
{
	global $aclFiles;
	if(isset($aclFiles))
	{
		foreach($aclFiles as $aclFile)
		{
			$aclFile->applyChanges();
		}
	}
}


function announce()
{
	global $announcements;
	if(isset($announcements) && sizeof($announcements)>0)
	{
		$message="";
		foreach($announcements as $announcement)
		{
			$message.="#sudo site eggtalk $announcement\n";
		}
		outputProgress($message,"a");
	}
}


function addError($error)
{
	global $errors;
	$errors[]=$error;
	echo $error . "\n";
}

function errorLog()
{
	global $SCRIPTPATH;
	global $errors;
	if(isset($errors) && sizeof($errors)>0)
	{
		$out=fopen("{$SCRIPTPATH}errors.log","a");
		foreach($errors as $error)
		{
			fwrite($out,date("Y/m/d H:i:s")." : $error\r\n");
		}
		fclose($out);
	}
}

function translatePath($path)
{
	$path=str_replace("\\","/",$path);
	if($path[strlen($path)-1] != "/")
	{
		$path="$path/";
	}
	return $path;
}

function loadUnwelcomedList()
{
	global $SCRIPTPATH;
	$lines=file("{$SCRIPTPATH}unwelcomed.conf");
	$NFOLIST="";
	foreach($lines as $line)
	{
		if(ini_get("magic_quotes_runtime"))
			$line=stripslashes($line);

		if($line[0] != "#" && strlen($line) > 0)
		{
			if($NFOLIST!="")
				$NFOLIST.=":";

			$NFOLIST.=strtolower($line);
		}
	}

	$patterns=array("\r","\n","[","]","(",")","."  ,":"    ,"*"  ,"?");
	$replace =array(""  ,""  ,"\\[","\\]","[(]","[)]","[.]","$)|(^",".*",".");
	$NFOLIST=str_replace($patterns,$replace,strtolower($NFOLIST));

	return "(^{$NFOLIST}$)";
}

// read config file
function init()
{
	global $SCRIPTPATH;

	register_shutdown_function("callShutdownFunctions");
	addShutdownFunction("errorLog");
	addShutdownFunction("updateAclFiles");

	define("RAIDENPATH"			,  5);  // these defines are for options that
	define("RIPPATH"			, 10); // need a special processing
	define("ROMSPATH"			, 10);
	define("CRCPATH"			, 20);
	define("MULTICDTEMPLATES"	, 30);

	if(file_exists("{$SCRIPTPATH}phpZipScript.conf"))
	{
		$alllines=file("{$SCRIPTPATH}phpZipScript.conf");
		foreach($alllines as $line)
		{
			$line=trim($line);
			if(ini_get("magic_quotes_runtime"))
				$line=stripslashes($line);

			if( strlen($line) > 3 && $line[0] != "#")
			{
				$tmp	= explode("=",$line);
				$a  	= strtoupper(trim($tmp[0]));
				if(isset($tmp[1]))
				{
					$b	= trim(implode(array_slice($tmp,1,sizeof($tmp)-1),"="));
				}
				else
				{
					$b ="";
				}

				$testB=strtolower($b);
				if( $testB!="false" && $testB!="off" &&
					$testB!="" 		&& $testB!="no")
				{
					global $$a;

					unset($const);
					$const=@constant($a);
					if(!$const)
						$const=0;
					switch($const) // do special processings 
					{
					case CRCPATH: // to ensure the path is written in a proper way
					case RAIDENPATH: 
						$$a=translatePath($b);
						break;
					case ROMSPATH:
					case RIPPATH: // construct a valid paths array
						${$a}[]=translatePath($b);
						break;
					case MULTICDTEMPLATES:
						$aTemp=explode(" ",$b);
						$temp2=array();
						foreach($aTemp as $index=>$temp)
						{
							$temp2[$index]="";
							for($i=0;$i<strlen($temp);$i++)
							{
								if($temp[$i]=='#')
									$temp2[$index].='[0-9]';
								else
								{
									switch($temp[$i])
									{
									case '^':
									case '$':
									case '[':
									case ']':
									case '(':
									case ')':
										$temp2[$index].="[\\".$temp[$i]."]";
										break;
									case '*':
										$temp2[$index].='.*';
										break;
									case '?':
										$temp2[$index].='.';
										break;
									case '.':
										$temp2[$index].='['.$temp[$i].']';
										break;
									default:
										$temp2[$index].=$temp[$i];
									}
								}
							}
						}
						$$a="(^".implode("$)|(^",$temp2)."$)";
						break;
					default: // normal options are just declared here
						$$a=$b;
					}
				}
			}
		}
	}
	else
	{
		addError("CONFIG FILE {$SCRIPTPATH}phpZipScript.conf NOT FOUND.");
		exit();
	}

	// loading database lib
	require("common.php");
	if(file_exists("{$SCRIPTPATH}DBlibs/$DBTYPE.inc.php"))
	{
		require("{$SCRIPTPATH}DBlibs/$DBTYPE.inc.php");
	}
	else
	{
		addError("Cannot load \"{$SCRIPTPATH}DBlibs/$DBTYPE.inc.php\". Trying to use text mode...");

		if(file_exists("{$SCRIPTPATH}DBlibs/text.inc.php"))
		{
			require("{$SCRIPTPATH}DBlibs/text.inc.php");
			addError("Text libs loaded.");
		}
		else
		{
			addError("Unable to find text libs either.");
			exit();
		}
	}
	if(!database_connect("localhost",$DBLOGIN,$DBPASSWORD))
	{
		addError("Unable to connect to the database.").
			exit();
	}
	require("{$SCRIPTPATH}AclFile.class.php");
}
init();
?>