# to run this script :
# 1. edit install.bat and change the path to mysql.exe to make it fit your system.
#   (if you have set a password for root user of mysql you'll have to change the line to
#   something like : c:\mysql\bin\mysql.exe -u root -p < phpZipScript.php
#   you will be asked the password when you'll run the .bat)
# 2. run install.bat and everything should be alright.

# creates the phpZipScript database
CREATE DATABASE phpZipScript;

USE phpZipScript;

# creates the tables of phpZipScript database

CREATE TABLE `releases` (
  `releaseID` int(11) NOT NULL auto_increment,
  `release` text NOT NULL,
  `virtualpath` text NOT NULL,
  `status` text NOT NULL,
  `nbfiles` smallint(6) NOT NULL default '0',
  `releasetype` text NOT NULL,
  `enddate` timestamp(14) NOT NULL,
  `creationdate` timestamp(14) NOT NULL,
  `creator` tinytext NOT NULL,
  PRIMARY KEY  (`releaseID`),
  UNIQUE KEY `ID` (`releaseID`),
  KEY `ID_2` (`releaseID`)
) TYPE=MyISAM;

CREATE TABLE `files` (
  `fileID` int(11) NOT NULL auto_increment,
  `releaseID` int(11) NOT NULL default '0',
  `filename` text NOT NULL,
  `filesize` int(11) NOT NULL default '0',
  `speed` int(11) NOT NULL default '0',
  `racer` text NOT NULL,
  `racergroup` text NOT NULL,
  `filedate` timestamp(14) NOT NULL,
  PRIMARY KEY  (`fileID`),
  UNIQUE KEY `fileID` (`fileID`),
  UNIQUE KEY `filename` (`filename`(40)),
  KEY `fileID_2` (`fileID`),
  KEY `filename_2` (`filename`(40))
) TYPE=MyISAM;

# this table is for later use
CREATE TABLE `mp3infos` (
  `fileID` int(11) NOT NULL default '0',
  `trackname` text NOT NULL,
  `artist` text NOT NULL,
  `album` text NOT NULL,
  `year` smallint(6) NOT NULL default '0',
  `genre` text NOT NULL,
  `bitrate` smallint(6) NOT NULL default '0',
  `frequency` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`fileID`),
  UNIQUE KEY `fileID` (`fileID`),
  KEY `fileID_2` (`fileID`)
) TYPE=MyISAM;

# this gives the script access to the database
# you can change the first part in 'phpZipScript'@'localhost' and 'php' to
# anything you want (as long as you update the phpZipScript.conf file.
# Those are the DBLogin and DBPass.
#
# eg: if you want to set the login/pass to blabla/lalala just change this line to:
# GRANT SELECT,INSERT,UPDATE,DELETE ON phpZipScript.* TO 'blabla'@'localhost' IDENTIFIED BY 'lalala';
# you mustn't change the second part of 'phpZipScript'@'localhost' (ie: @'localhot') 
GRANT SELECT,INSERT,UPDATE,DELETE ON phpZipScript.* TO 'phpZipScript'@'localhost' IDENTIFIED BY 'php';
