<?php
error_reporting(E_ALL);

$SCRIPTPATH=str_replace("\\","/",realpath(dirname(__FILE__)))."/";

require("{$SCRIPTPATH}init.php");

if(!isset($argv))
{
	if(isset($_SERVER["argv"]))
		$argv=$_SERVER["argv"];
	else
	{
		addError("Unable to retrieve the arguments in ".__FILE__.". Make sure you have 'register_argc_argv=On' in you php.ini file!");
		exit();
	}
}

if(sizeof($argv) < 5)
{
	addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
	exit();
}

$patterns=array("\r","\n","[","]","(",")","."  ,":"    ,"*"  ,"?");
$replace =array(""  ,""  ,"\\[","\\]","[(]","[)]","[.]","$)|(^",".*",".");
$BANNEDFOLDERS="(^".str_replace($patterns,$replace,strtolower(implode(":",splitOption($BANNEDFOLDERS))))."$)";

$virtualpath=urldecode($argv[1]);
$fullpath=urldecode($argv[2])."\\";
initPathVars();
$username=$argv[3];
$GCID=$argv[4];


$message="";

if(!$multiCD && eregi($BANNEDFOLDERS,$release))
{
	$accept=0;
	$message=" This folder has been banned from this server. ";
}
else
{
	if(!release_exists($release))
	{
		$accept=1;
		insert_release($release,$fullpath,$virtualpath,$username); 
	}
	else
	{
		if($multiCD)
		{
			update_release_status(basename(dirname($fullpath)),"MULTI-CD");
		}
		else
		{
			if(isset($FOLDERSDUPECHECKING) && $FOLDERSDUPECHECKING!="")
			{
				$accept=0;
				$message=" This folder is a dupe. ";
			}
		}
	}
}

outputProgress($message,"w+","ask-onNewDir",$accept);
?>