<?php
error_reporting(E_ALL);

$SCRIPTPATH=str_replace("\\","/",realpath(dirname(__FILE__)))."/";

require("{$SCRIPTPATH}init.php");

if(!isset($argv))
{
	if(isset($_SERVER["argv"]))
		$argv=$_SERVER["argv"];
	else
	{
		addError("Unable to retrieve the arguments in ".__FILE__.". Make sure you have 'register_argc_argv=On' in you php.ini file!");
		exit();
	}
}

require("{$SCRIPTPATH}sfv.php");

$event=$argv[1];

if(!isset($argv))
$argv=$_SERVER["argv"];

switch($event)
{
case "sfv":
	{
		if(sizeof($argv) < 8)
		{
			addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
			exit();
		}

		$fullpath=dirname($argv[2])."\\";
		initPathVars();

		$sfvFileName=basename($argv[2]);
		$fullpath83=$argv[3];
		$nbfiles=$argv[4];
		$username=$raceLeader=$argv[5];
		$usergroup=$leadingGroup=$leaderGroup=$argv[6];
		$GCID=$argv[7];

		onSfvUploaded();
		break;
	}
case "success":
	{
		if(sizeof($argv) < 10)
		{
			addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
			exit();
		}

		$fullpath=dirname($argv[2])."\\";
		initPathVars();
		$filename=basename($argv[2]);
		$fullpath83=$argv[3];
		$filename83=$argv[4];
		$nbfiles=$argv[5];
		$lastSpeed=$argv[6];
		$username=$argv[7];
		$usergroup=$argv[8];
		$GCID=$argv[9];

		onSfvSuccess();
		break;
	}
case "complete":
	{
		// not needed in fact... may be used later
		break;
	}
case "failed":
	{
		if(sizeof($argv) < 4)
		{
			addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
			exit();
		}

		$fullpath=dirname($argv[2])."\\";
		$filename=basename($argv[2]);
		initPathVars();
		$GCID=$argv[3];

		onSfvFailed();
		break;
	}
case "delete":
	{
		if(sizeof($argv) < 3)
		{
			addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
			exit();
		}

		$fullpath=dirname($argv[2])."\\";

		initPathVars();	

		onSfvPreDelete();
		break;
	}
default:
	{
		addError("Unknow sfv event : \"$event\" in ".__FILE__.".");
	}
}
?>