<?php
$SCRIPTPATH=str_replace("\\","/",realpath(dirname(__FILE__)))."/";

require("{$SCRIPTPATH}init.php");

if(!isset($argv))
{
	if(isset($_SERVER["argv"]))
		$argv=$_SERVER["argv"];
	else
	{
		addError("Unable to retrieve the arguments in ".__FILE__.". Make sure you have 'register_argc_argv=On' in you php.ini file!");
		exit();
	}
}

if(sizeof($argv) < 3)
{
	addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
	exit();
}

$filename=basename($argv[1]);
$fullpath=dirname($argv[1])."\\";
$GCID=$argv[2];

$unwelcomed=loadUnwelcomedList();
$message="";

if(isset($ALLOWNOTINSFV) && $ALLOWNOTINSFV!="")
{
	$patterns=array("\r","\n","[","]","(",")","."  ,":"    ,"*"  ,"?");
	$replace =array(""  ,""  ,"\\[","\\]","[(]","[)]","[.]","$)|(^",".*",".");
	$ALLOWNOTINSFV="(^".str_replace($patterns,$replace,strtolower(implode(":",splitOption($ALLOWNOTINSFV))))."$)";
}
if(ereg($unwelcomed,strtolower($filename)))
{
	$accept=0;
	$message=" You are not allowed to upload $filename. \n This file has been banned from this server. ";
}
else if(isset($ALLOWNOTINSFV) && $ALLOWNOTINSFV!="" && eregi($ALLOWNOTINSFV,$filename))
{
	$accept=1;
}
else if(!(isset($ALLOWDIZUPLOAD) && $ALLOWDIZUPLOAD!="") && strtolower($filename)=="file_id.diz")
{
	$accept=0;
	$message=" You are not allowed to upload 'file_id.diz'. \n It will be automatically extracted from the zip files. ";
}
else if(isset($SFVFIRST) && $SFVFIRST)
{
	$extension=strtolower(substr($filename,strrpos($filename,".")+1));
	require("{$SCRIPTPATH}sfv.php");

	switch($extension)
	{
	case "zip":
	case "sfv":
	case "nfo":
		$accept=1;
		break;
	default:
		if($filename!="file_id.diz" && ($sfvfilename=findSfv())=="")
		{
			$accept=0;
			$message=" No sfv found for this release. \n Please send the sfv file before any other file. ";
		}
		else
		{
			$sfv=analyseSfv($sfvfilename);
			if(!isset($sfv[strtolower($filename)]))
			{
				$accept=0;
				$message=" $filename is not listed in the sfv ! ";
			}
			else
			{
				$accept=1;
			}
		}
	}
}
else
{
	$accept=1;
}

outputProgress($message,"w+","ask-onFilePreUpload",$accept);
?>