<?php
function onSfvUploaded($simulate=false)
{
	global $fullpath,$release,$fullpath83,$nbfiles,$sfvFileName;
	global $CREATEMISSINGFILES,$MISSINGFILESSUFFIX,$SITENFO;
	global $SCRIPTPATH;

	update_release_nbfiles($release,$nbfiles);
	list($missingFiles,$presentFiles)=findMissingSfvFiles($sfvFileName);

	$i=0;
	if(sizeof($presentFiles)>0)
	{
		outputProgress(" Checking present files, it may take some time... ","w");
	}
	foreach($presentFiles as $file=>$crc)
	{
		set_time_limit(10);
		$useFileCheck=isFileName83($file)?"fastFileCheck":"fileCheck";

		if(!$useFileCheck("{$fullpath83}$file",$crc))
		{
			renameBadFile($fullpath83.$file,true);
			$missingFiles[]=$file;
			array_splice($presentFiles,$i,1);
		}
		sleep(1);
		$i++;
	}
	set_time_limit(5);
	$raceinfos=request_raceinfo($release);
	foreach($raceinfos as $raceitem)
	{
		if(!isset($presentFiles[$raceitem[2]]))
		{
			delete_file($release,$raceitem[2]);
		}
	}

	if(isset($CREATEMISSINGFILES) && $CREATEMISSINGFILES!="" && $nbfiles > 1)
	{
		$MISSINGFILESSUFFIX=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MISSINGFILESSUFFIX);
		if(!isset($MISSINGFILESSUFFIX) || $MISSINGFILESSUFFIX=="")
			$MISSINGFILESSUFFIX="-missing";

		createMissingTags($missingFiles);
	}
	process_raceinfo();
	$nfos=splitOption($SITENFO);
	foreach($nfos as $nfo)
	{
		if(file_exists($nfo))
		{
			$nfoname=basename($nfo);
			if($nfoname=="")
			{
				$nfoname=$nfo;
				$nfo=$SCRIPTPATH.$nfo;
			}
			copy($nfo,$fullpath.$nfoname);
		}
	}
}

function onSfvSuccess($simulate=false)
{
	global $release,$fullpath,$filename;
	global $lastSpeed, $username,$usergroup;

	global $MISSINGFILESSUFFIX;
	global $aclFiles;

	$filename=strtolower($filename);

	global $MISSINGFILESSUFFIX;
	$MISSINGFILESSUFFIX=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MISSINGFILESSUFFIX);
	if(!isset($MISSINGFILESSUFFIX) || $MISSINGFILESSUFFIX=="")
		$MISSINGFILESSUFFIX="-missing";

	@unlink("$fullpath{$filename}$MISSINGFILESSUFFIX");
	$aclFiles["releaseDir"]->delete($filename.$MISSINGFILESSUFFIX);

	$filesize=filesize($fullpath.$filename);
	insert_file($release,$filename,$filesize,$lastSpeed,$username,$usergroup);
	process_raceinfo();
}

function onSfvFailed($simulate=false)
{
	global $filename,$fullpath,$SCRIPTPATH,$GCID;
	outputProgress("\n $filename was bad ! \n","w+");

	if($simulate)
	{
		renameBadFile($fullpath.$filename);
		outputProgress("#sudo site undupe $filename","a");
		// FAIRE DU MENAGE DANS LE SFV ET METTRE UN CHMOD SUR LE .bad
	}
	else
	{
		if(!file_exists("{$SCRIPTPATH}tmp"))
		{
			@mkdir("{$SCRIPTPATH}tmp");
		}
		fclose(fopen("{$SCRIPTPATH}tmp\\$filename.$GCID.bad","w+"));
	}
}

function onSfvPreDelete($simulate=false)
{
	global $fullpath,$release,$aclFiles;

	global $MISSINGFILESSUFFIX,$MESSAGEFILENAME;

	delIncompleteTags();

	if(!isset($MESSAGEFILENAME) || $MESSAGEFILENAME=="")
		$MESSAGEFILENAME=".message";

	if(file_exists($fullpath.$MESSAGEFILENAME))
	{
		unlink($fullpath.$MESSAGEFILENAME);
		$aclFiles["releaseDir"]->delete($MESSAGEFILENAME);
	}

	// should use the delIncompleteTags function
	$MISSINGFILESSUFFIX=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MISSINGFILESSUFFIX);
	if(!isset($MISSINGFILESSUFFIX) || $MISSINGFILESSUFFIX=="")
		$MISSINGFILESSUFFIX="-missing";

	$missingSuffixLength=strlen($MISSINGFILESSUFFIX);

	$handle=opendir($fullpath);
	while($file = readdir($handle))
	{
		if( strtolower(substr($file,-$missingSuffixLength)) == strtolower($MISSINGFILESSUFFIX))
		{
			unlink($fullpath.$file);
			$aclFiles["releaseDir"]->delete($file);
		}
	}
	closedir($handle);
}

function isFileName83($filename)
{
	if(strlen($filename)>13)
		return false;

	if(strrpos($filename,".")>9)
		return false;

	if(ereg("[[:blank:]]",$filename))
		return false;

	return true;
}

function renameBadFile($filepath,$force=false)
{
	global $SCRIPTPATH,$SFVCHECK;
	global $username,$usergroup;
	global $aclFiles;

	if($force && (!isset($SFVCHECK) || $SFVCHECK=="" || $SFVCHECK=="0"))
		$SFVCHECK="1";

	if(file_exists("$filepath.bad"))
		unlink("$filepath.bad");
	switch($SFVCHECK)
	{
	case "1":
		rename($filepath,"$filepath.bad");
		$aclFiles["releaseDir"]->rename(basename($filepath),basename("$filepath.bad"));
		//			exec("{$SCRIPTPATH}chmod.exe 110 $username $usergroup \"$filepath.bad\"");
		break;
	case "2":
		unlink($filepath);
		$aclFiles["releaseDir"]->delete(basename($filepath));
		break;
	case "3":
		unlink($filepath);
		fclose(fopen("$filepath.bad","w+"));
		$aclFiles["releaseDir"]->rename(basename($filepath),basename("$filepath.bad"));
		//			exec("{$SCRIPTPATH}chmod.exe 110 $username $usergroup \"$filepath.bad\"");
		break;
	}
}

// this function can only work with 8.3 paths
function fastFileCheck($filepath83,$crc)
{
	global $SCRIPTPATH;
	$cmd="{$SCRIPTPATH}crc32.com $filepath83 $crc";
	exec($cmd,$result,$returnValue);
	if($returnValue==1)
	{
		return false;
	}
	return true;
}

function fileCheck($filepath,$crc)
{
	global $SCRIPTPATH;

	$cmd="{$SCRIPTPATH}crc32.exe \"$filepath\"";
	exec($cmd,$result,$returnValue);

	if(filesize($filepath)==0 || ereg("0x[0-9a-f]{8}",$result[0],$regs))
	{
		if(strtolower("0x".$crc)!=$regs[0])
		{
			return false;
		}
	}
	return true;
}

function findSfv()
{
	global $fullpath;
	$sfvFileName="";

	$dir = opendir($fullpath);
	while($file = readdir($dir))
	{
		if(strtolower(substr($file,strrpos($file,".")+1))=="sfv")
		{
			$sfvFileName=$file;
			break;
		}
	}
	closedir($dir);

	return $sfvFileName;
}

function analyseSfv($sfvFileName)
{
	global $fullpath;

	$sfv=array();

	if($lines=file($fullpath.$sfvFileName));
	{
		foreach($lines as $line)
		{
			$line=trim($line);
			if(strlen($line)>0 && $line[0]!=";")
			{
				$temp=explode(" ",trim($line));
				if(sizeof($temp)>1)
				{
					$CRC=strtoupper(array_pop($temp));
					$filename=strtolower(trim(implode(" ",$temp)));

					if(!isset($sfv[$filename]))
					{
						$sfv[$filename]=$CRC;
					}
				}
			}
		}
	}
	return $sfv;
}

function findMissingSfvFiles($sfvFileName)
{
	global $fullpath;
	global $SFVCOMMENTHEADER, $SFVCOMMENTFOOTER, $SFVCLEANING;

	$missingFiles=array();
	$presentFiles=array();

	$tempSfv="";

	if($lines=file($fullpath.$sfvFileName));
	{
		$files=array();
		foreach($lines as $line)
		{
			$line=trim($line);
			if(strlen($line)>0 && $line[0]!=";")
			{
				$temp=explode(" ",trim($line));
				if(sizeof($temp)>1)
				{
					$CRC=strtoupper(array_pop($temp));
					$filename=strtolower(trim(implode(" ",$temp)));

					if(!in_array($filename,$missingFiles) && !isset($presentFiles[$filename]))
					{
						$tempSfv.="$filename $CRC\r\n";
						if(!file_exists($fullpath.$filename))
						{
							$missingFiles[]=trim($filename);
						}
						else
						{
							$presentFiles[$filename]=$CRC;
						}
					}
				}
			}
		}

		$updateSfv=false;
		if(isset($SFVCLEANING) && $SFVCLEANING!="")
		{
			$newSfv=$tempSfv;
			$updateSfv=true;
		}
		else
		{
			$newSfv=implode("",$lines);
		}

		if(isset($SFVCOMMENTHEADER) && $SFVCOMMENTHEADER!="")
		{
			$newSfv=getSfvComment($SFVCOMMENTHEADER).$newSfv;
			$updateSfv=true;
		}

		if(isset($SFVCOMMENTFOOTER) && $SFVCOMMENTFOOTER!="")
		{
			if($newSfv[strlen($newSfv)-1]!="\n")
				$newSfv.="\r\n";
			$newSfv.=getSfvComment($SFVCOMMENTFOOTER);
			$updateSfv=true;
		}

		if($updateSfv)
		{
			$fp=fopen($fullpath.$sfvFileName,"w+");
			fwrite($fp,$newSfv);			
			fclose($fp);

		}
	}
	return array($missingFiles,$presentFiles);
}

function getSfvComment($comment)
{
	$newComment="";
	if(isset($comment) && $comment!="")
	{
		if(file_exists($comment))
		{
			$lines=file($comment);
			foreach($lines as $line)
			{
				$line=trim($line);
				$newComment.="; $line\r\n";
			}
		}
		else
		{
			$newComment="; $comment\r\n";
		}
	}
	return $newComment;
}
?>